package com.javielinux.facemix;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

import org.xmlpull.v1.XmlPullParserException;

import utils.Utils;
import zoom.WrapMotionEvent;
import android.app.Activity;
import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.PointF;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.os.Vibrator;
import android.util.DisplayMetrics;
import android.util.FloatMath;
import android.view.GestureDetector;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.animation.LayoutAnimationController;
import android.view.animation.Animation.AnimationListener;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.SeekBar;
import android.widget.ImageView.ScaleType;

import com.android.dataframework.DataFramework;
import com.android.dataframework.Entity;

public class AdjustImage extends Activity implements OnTouchListener
{
	
	private static final int OK_ID = Menu.FIRST;
		
	private long mGroupId = 1;
	
    private int screen_w = 320;
    private int screen_h = 480;
        
    private Bitmap mBitmap = null;
    
    private boolean lock = false;
    
    private LinearLayout mllButtons;
    private ImageView mImgBtnAnim;
    private LinearLayout mllOpacity;
    
    private Bitmap mBmpModel;
    
    private float imageWidth = 0;
    private float imageHeight = 0;

    private BitmapDrawable mPhotoAlpha = null;
     
    private ImageView mImage;  
    private Resources res;
        
    private String file = "";
    
    private Matrix matrix = new Matrix();
    private Matrix savedMatrix = new Matrix();
    
    private float mScale = 1f;
    
    static final int TYPE_ZOOM_NORMAL = 0;
    static final int TYPE_ZOOM_VERTICAL = 1;
    static final int TYPE_ZOOM_HORIZONTAL = 2;

    static final int NONE = 0;
    static final int DRAG = 1;
    static final int ZOOM = 2;
    static final int ZOOM_ONEFINGER = 3;
    int mode = NONE;

    PointF start = new PointF();
    PointF mid = new PointF();
    PointF startOneFinger = new PointF();
    float oldDist = 1f;
    
    private SeekBar mSbOpacity;
    
    private List<Entity> mEntitiesImages;
    private int mCurrentImage = 0;
    private int mTypeImage = Utils.TYPE_IMAGE_NORMAL;
    private ImageView mImageForeground;
    private GestureDetector gd;
    
    private ImageView mImageTypeZoom;
    private int mTypeZoom = TYPE_ZOOM_NORMAL;
    private ImageView mImageTypeRotate;
    
         
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState); 
        
        if (savedInstanceState != null) {
			if (savedInstanceState.containsKey("file")) file = savedInstanceState.getString("file");
			if (savedInstanceState.containsKey("group")) mGroupId = savedInstanceState.getLong("group");
		} else {
			Bundle extras = getIntent().getExtras();  
			if (extras != null) {
				file = (extras.containsKey("file")) ? extras.getString("file") : "";
				mGroupId = (extras.containsKey("group")) ? extras.getLong("group") : 1;
			} else {
				file = "";
				mGroupId = 1;
			}
		}
        
        requestWindowFeature(Window.FEATURE_NO_TITLE);  
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,   
                                WindowManager.LayoutParams.FLAG_FULLSCREEN); 
        
        try {
			DataFramework.getInstance().open(this, Utils.appPackage);
		} catch (XmlPullParserException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		gd = new GestureDetector(new GestureDetector.SimpleOnGestureListener(){
			@Override
			public void onLongPress(MotionEvent e) {
				if (Utils.preference.getBoolean("prf_zoom_one_finger", false)) {
					((Vibrator) getSystemService(Context.VIBRATOR_SERVICE)).vibrate(100); 
					mode = ZOOM_ONEFINGER;
					startOneFinger.set(e.getX(), e.getY());
				}
			}			
		});
        
        res = getResources();
        
        mid.x = 0f;
        mid.y = 0f;
        
        DisplayMetrics dm = res.getDisplayMetrics();
        screen_w = dm.widthPixels;
        screen_h = dm.heightPixels;
  
        mBitmap = Utils.getBitmap(file);
        imageWidth = mBitmap.getWidth();
        imageHeight = mBitmap.getHeight();
        
        FrameLayout fr = new FrameLayout(this);
                                
        mImage = new ImageView(this);
        mImage.setImageBitmap(mBitmap);
        
        float scrollX = (-(imageWidth/2))+(screen_w/2);
        float scrollY = (-(imageHeight/2))+(screen_h/2);

        mImage.setScaleType(ScaleType.MATRIX);
        mImage.setOnTouchListener(this);
        matrix.setTranslate(scrollX, scrollY);
        mImage.setImageMatrix(matrix);
        
        fr.addView(mImage);
        
        mCurrentImage = 0;
        mTypeImage = Utils.TYPE_IMAGE_NORMAL;
        
        mImageForeground = new ImageView(this);
        int height = screen_h*320/screen_w;
        int y = 400-(height/2);
        mBmpModel = Bitmap.createBitmap(BitmapFactory.decodeResource(this.getResources(), R.drawable.model), 0, y, 320, height, null, true);
        mImageForeground.setImageBitmap(mBmpModel);
        fr.addView(mImageForeground);
        
        mEntitiesImages = DataFramework.getInstance().getEntityList("images", "group_id="+mGroupId, "");
        /*if (mEntitiesImages.size()>0) {
        	hasPhotoAlpha = true;
            mPhotoAlpha = new BitmapDrawable(mEntitiesImages.get(0).getString("file"));
            mPhotoAlpha.setAlpha(Utils.START_PHOTO_ALPHA);
            mImageForeground = new ImageView(this);
            mImageForeground.setImageDrawable(mPhotoAlpha);            
            fr.addView(mImageForeground);
        }
        */
    
    	mllOpacity = new LinearLayout(this);
        mllOpacity.setVisibility(View.GONE);
        mllOpacity.setOrientation(LinearLayout.HORIZONTAL);
        mllOpacity.setLayoutParams(new LinearLayout.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT));
        
        mSbOpacity = new SeekBar(this);
        mSbOpacity.setMax(255);
        mSbOpacity.setProgress(Utils.START_PHOTO_ALPHA);
        
        mSbOpacity.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {

			@Override
			public void onProgressChanged(SeekBar arg0, int arg1, boolean arg2) {
				mPhotoAlpha.setAlpha(arg0.getProgress());
				mImage.invalidate();
			}

			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
			}

			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
			}
        	
        });
        
        mllOpacity.addView(mSbOpacity, new ViewGroup.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT));
        
        fr.addView(mllOpacity);
    
        // botones inferiores
    	// botn para hacer la animacin
    	
    	LinearLayout llButtons = new LinearLayout(this);
    	llButtons.setPadding(0, 0, 0, 10);
    	llButtons.setOrientation(LinearLayout.HORIZONTAL);
    	llButtons.setGravity(Gravity.BOTTOM);
    	llButtons.setLayoutParams(new LinearLayout.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT, LinearLayout.LayoutParams.FILL_PARENT));
    	
    	mImgBtnAnim = new ImageView(this);
    	mImgBtnAnim.setImageResource(R.drawable.btn_switch_off);
        
    	mImgBtnAnim.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (mllButtons.getVisibility() == View.GONE) {
					lock = true;
					mImageTypeZoom.setVisibility(View.GONE);
					mImageTypeRotate.setVisibility(View.GONE);
					LayoutAnimationController lacBtn = AnimationUtils.loadLayoutAnimation(AdjustImage.this, R.anim.inlayout_button_embed);
					lacBtn.setDelay(0);
					mllButtons.setLayoutAnimation(lacBtn);
					mllButtons.setLayoutAnimationListener(null);
					mllButtons.startLayoutAnimation();
					
					LayoutAnimationController lacOpac = AnimationUtils.loadLayoutAnimation(AdjustImage.this, R.anim.inlayout_opacity_embed);
					lacOpac.setDelay(0);
					mllOpacity.setLayoutAnimation(lacOpac);
					mllOpacity.setLayoutAnimationListener(null);
					mllOpacity.startLayoutAnimation();
					
					mllButtons.setVisibility(View.VISIBLE);
					mllOpacity.setVisibility(View.VISIBLE);
					mImgBtnAnim.setImageResource(R.drawable.btn_switch_on);
				} else {
					lock = false;
					mImageTypeZoom.setVisibility(View.VISIBLE);
					mImageTypeRotate.setVisibility(View.VISIBLE);
					LayoutAnimationController lac = AnimationUtils.loadLayoutAnimation(AdjustImage.this, R.anim.outlayout_button_embed);
					lac.setDelay(0);
					mllButtons.setLayoutAnimation(lac);
					mllButtons.setLayoutAnimationListener(new AnimationListener() {
				        @Override
				        public void onAnimationEnd(Animation lac) {
				        	mllButtons.setVisibility(View.GONE);
				        }
				
				        @Override
				        public void onAnimationRepeat(Animation animation) { }
				
				        @Override
				        public void onAnimationStart(Animation animation) { }
				
				    });
					mllButtons.startLayoutAnimation();
					
					LayoutAnimationController lacOpac = AnimationUtils.loadLayoutAnimation(AdjustImage.this, R.anim.outlayout_opacity_embed);
					lacOpac.setDelay(0);
					mllOpacity.setLayoutAnimation(lacOpac);
					mllOpacity.setLayoutAnimationListener(new AnimationListener() {
				        @Override
				        public void onAnimationEnd(Animation lac) {
							mllOpacity.setVisibility(View.GONE);
				        }
				
				        @Override
				        public void onAnimationRepeat(Animation animation) { }
				
				        @Override
				        public void onAnimationStart(Animation animation) { }
				
				    });
					mllOpacity.startLayoutAnimation();
					
					mImgBtnAnim.setImageResource(R.drawable.btn_switch_off);
				}
			}        	
        });
    	
    	llButtons.addView(mImgBtnAnim, new LinearLayout.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT));
    	
    	fr.addView(llButtons);
    	
    	// botones
    	
    	mllButtons = new LinearLayout(this);
    	mllButtons.setVisibility(View.GONE);
    	mllButtons.setPadding(0, 0, 0, 10);
    	mllButtons.setOrientation(LinearLayout.HORIZONTAL);
    	mllButtons.setGravity(Gravity.BOTTOM);
    	mllButtons.setLayoutParams(new LinearLayout.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT, LinearLayout.LayoutParams.FILL_PARENT));
        
        LinearLayout.LayoutParams llb1 = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
        llb1.weight = 1;
        
        LinearLayout.LayoutParams llb2 = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
        llb2.weight = 1;
        llb2.bottomMargin = 50;
        
        ImageView imgBtnPrevious = new ImageView(this);
        imgBtnPrevious.setImageResource(R.drawable.btn_left);
        
        imgBtnPrevious.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (mCurrentImage<=0) {
					mCurrentImage = mEntitiesImages.size();
				} else {
					mCurrentImage--;
				}
				refreshPhoto();
			}        	
        });
        
        mllButtons.addView(imgBtnPrevious, llb1);
        
        ImageView imgBtnSave = new ImageView(this);
        imgBtnSave.setImageResource(R.drawable.btn_save);
        
        imgBtnSave.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				save();
			}        	
        });
        
        mllButtons.addView(imgBtnSave, llb2);
        
        ImageView imgBtnNext = new ImageView(this);
        imgBtnNext.setImageResource(R.drawable.btn_right);
        
        imgBtnNext.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (mCurrentImage>=mEntitiesImages.size()) {
					mCurrentImage = 0;
				} else {
					mCurrentImage++;
				}
				refreshPhoto();
			}        	
        });
        
        mllButtons.addView(imgBtnNext, llb1);
        
        fr.addView(mllButtons);
        
        // botones de zoom y rotar
        
        LinearLayout llButtonsZoom = new LinearLayout(this);
        llButtonsZoom.setPadding(0, 0, 0, 10);
        llButtonsZoom.setOrientation(LinearLayout.HORIZONTAL);
        llButtonsZoom.setGravity(Gravity.TOP);
        llButtonsZoom.setLayoutParams(new LinearLayout.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT));
        
        mImageTypeZoom = new ImageView(this);
        mImageTypeZoom.setImageResource(R.drawable.btn_zoom);
        mImageTypeZoom.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				if (mTypeZoom>=2) {
					mTypeZoom = 0;
				} else {
					mTypeZoom++;
				}
				if (mTypeZoom==TYPE_ZOOM_NORMAL) {
					mImageTypeZoom.setImageResource(R.drawable.btn_zoom);
				} else if (mTypeZoom==TYPE_ZOOM_VERTICAL) {
					mImageTypeZoom.setImageResource(R.drawable.btn_zoom_vertical);
				} else if (mTypeZoom==TYPE_ZOOM_HORIZONTAL) {
					mImageTypeZoom.setImageResource(R.drawable.btn_zoom_horizontal);
				}
			}
        	
        });
        
        llButtonsZoom.addView(mImageTypeZoom);
        
        LinearLayout.LayoutParams lpTransparent = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
        lpTransparent.weight = 1;
        ImageView transparent = new ImageView(this);
        
        llButtonsZoom.addView(transparent, lpTransparent);
        
        mImageTypeRotate = new ImageView(this);
        mImageTypeRotate.setImageResource(R.drawable.btn_rotate);
        mImageTypeRotate.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				matrix.set(savedMatrix);
				matrix.postRotate(90, screen_w/2, screen_h/2);
				mImage.setImageMatrix(matrix);
				savedMatrix.set(matrix);
			}
        	
        });
        
        llButtonsZoom.addView(mImageTypeRotate);
        
        fr.addView(llButtonsZoom);//, new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT));
        
        setContentView(fr, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.FILL_PARENT, ViewGroup.LayoutParams.FILL_PARENT));
    }
    
    private void refreshPhoto() {
    	if (mCurrentImage==0) { // ponemos el modelo
    		mImageForeground.setImageBitmap(mBmpModel);
    	} else { // ponemos foto
	    	if (mTypeImage==Utils.TYPE_IMAGE_EDGE)
	    		mPhotoAlpha = new BitmapDrawable(Utils.edgeFinder(mEntitiesImages.get(mCurrentImage-1).getString("file"), Utils.THRESHOLD));
	    	else
	    		mPhotoAlpha = new BitmapDrawable(mEntitiesImages.get(mCurrentImage-1).getString("file"));
	    	
	    	mPhotoAlpha.setAlpha(Utils.START_PHOTO_ALPHA);
	    	
	    	mImageForeground.setImageDrawable(mPhotoAlpha);  
    	}
		mImage.invalidate();
    }
   
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        menu.add(0, OK_ID, 0,  R.string.save)
			.setIcon(android.R.drawable.ic_menu_save);
        return true;
    }
    
    @Override
    public boolean onMenuItemSelected(int featureId, MenuItem item) {
        switch(item.getItemId()) {
        case OK_ID:
        	save();
        	return true;
        }
       
        return super.onMenuItemSelected(featureId, item);
    }
    
    private void save() {
    	Bitmap outBitmap = null;
    	
    	outBitmap = Bitmap.createBitmap(screen_w, screen_h, Bitmap.Config.RGB_565);
    	Canvas c = new Canvas(outBitmap);
    	c.drawColor(Color.BLACK);
    	c.drawBitmap(mBitmap, matrix, null);
    	
    	String auxFile = Utils.appDirectory + "aux.png";

    	FileOutputStream out;
		try {
			out = new FileOutputStream(auxFile);
			outBitmap.compress(Bitmap.CompressFormat.PNG, 100, out);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		outBitmap.recycle();
		outBitmap = null;	


		setResult(RESULT_OK);
        finish();
    }
        
    @Override
    public boolean onTouch(View v, MotionEvent rawEvent) {
    	if (!lock) {
	    	WrapMotionEvent event = WrapMotionEvent.wrap(rawEvent);
	    	ImageView view = (ImageView) v;
	
	    	switch (event.getAction() & MotionEvent.ACTION_MASK) {
	    	case MotionEvent.ACTION_DOWN:
	    		savedMatrix.set(matrix);
	    		start.set(event.getX(), event.getY());
	    		mode = DRAG;
	    		break;
	    	case MotionEvent.ACTION_POINTER_DOWN:
	    		oldDist = spacing(event);
	    		if (oldDist > 10f) {
	    			savedMatrix.set(matrix);
	    			midPoint(mid, event);
	    			mode = ZOOM;
	    		}
	    		break;
	    	case MotionEvent.ACTION_UP:
	    	case MotionEvent.ACTION_POINTER_UP:
	    		mode = NONE;
	    		break;
	    	case MotionEvent.ACTION_MOVE:
	    		if (mode == DRAG) {
	    			matrix.set(savedMatrix);
	    			matrix.postTranslate(event.getX() - start.x, event.getY() - start.y);
	    		} else if (mode == ZOOM) {
	    			float newDist = spacing(event);
	    			if (newDist > 10f) {
	    				matrix.set(savedMatrix);
	    				mScale = newDist / oldDist;
	    				float scale_x = 1;
	    				float scale_y = 1;
	    				if (mTypeZoom==TYPE_ZOOM_NORMAL) {
	    					scale_x = mScale;
	    					scale_y = mScale;
	    				} else if (mTypeZoom==TYPE_ZOOM_VERTICAL) {
	    					scale_y = mScale;
	    				} else if (mTypeZoom==TYPE_ZOOM_HORIZONTAL) {
	    					scale_x = mScale;
	    				}
	    				matrix.postScale(scale_x, scale_y, mid.x, mid.y);
	    			}
	    		} else if (mode == ZOOM_ONEFINGER) {
	    			float y = startOneFinger.y - event.getY(0);
	    			if ( (y > 10f) || (y < -10f) ) {
	    				matrix.set(savedMatrix);
	    				mScale = 1.0f + (y / (screen_h/2));
	    				float scale_x = 1;
	    				float scale_y = 1;
	    				if (mTypeZoom==TYPE_ZOOM_NORMAL) {
	    					scale_x = mScale;
	    					scale_y = mScale;
	    				} else if (mTypeZoom==TYPE_ZOOM_VERTICAL) {
	    					scale_y = mScale;
	    				} else if (mTypeZoom==TYPE_ZOOM_HORIZONTAL) {
	    					scale_x = mScale;
	    				}
	    				matrix.postScale(scale_x, scale_y, startOneFinger.x, startOneFinger.y);
	    			}
	    		}
	    		break;
	    	}
	    	
	    	view.setImageMatrix(matrix);
	    	gd.onTouchEvent(rawEvent);
    	}
    	return true;
    }
	   
    private float spacing(WrapMotionEvent event) {
    	float x = event.getX(0) - event.getX(1);
    	float y = event.getY(0) - event.getY(1);
    	return FloatMath.sqrt(x * x + y * y);
    }

    private void midPoint(PointF point, WrapMotionEvent event) {
    	float x = event.getX(0) + event.getX(1);
    	float y = event.getY(0) + event.getY(1);
    	point.set(x / 2, y / 2);
    }
    
	@Override
	protected void onDestroy() {
		super.onDestroy();
		mBitmap.recycle();
		mBitmap = null;	
		DataFramework.getInstance().close();
	}
    
}