package com.javielinux.facemix;

import info.Img;
import info.WorkspaceView;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import utils.Utils;
import adapters.PhotosViewAdapter;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Matrix;
import android.net.Uri;
import android.os.Bundle;
import android.os.SystemClock;
import android.provider.MediaStore;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.animation.LayoutAnimationController;
import android.view.animation.Animation.AnimationListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.LinearLayout.LayoutParams;

import com.android.dataframework.DataFramework;
import com.android.dataframework.Entity;

public class FaceMix extends Activity {
	
	private static final int PREFERENCES_ID = Menu.FIRST;
	
    private static final int ACTIVITY_CAMERA = 0;
    private static final int ACTIVITY_SELECTIMAGE = 2;
    private static final int ACTIVITY_EMBED = 3;
    
    private static final int DIALOG_DELETE = 0;
    private static final int DIALOG_IMAGE = 1;
    
    public int mScreenHeight = 0;
    public int mScreenWidth = 0;
        
    private int mPosDeletePhoto = -1;
       
    private LinearLayout mContentLayout = null;
    
    private WorkspaceView mWorkspaceView;
    
    private boolean isActionsPhoto = false;
    
    private Img mImgSelected;
    
    private LinearLayout llBlack;
    
    private ArrayList<PhotosViewAdapter> mArrayAdapter = new  ArrayList<PhotosViewAdapter>();
		
    @Override
    protected Dialog onCreateDialog(int id) {
        switch (id) {
        case DIALOG_DELETE:
            return new AlertDialog.Builder(this)
                .setTitle(R.string.title_question_delete)
                .setMessage(R.string.question_delete)
                .setPositiveButton(R.string.accept, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                    	deletePhoto();
                    }
                })
                .setNegativeButton(R.string.cancel, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                    }
                })
                .create();
        case DIALOG_IMAGE:
            return new AlertDialog.Builder(FaceMix.this)
                .setTitle(R.string.select_action_photo)
                .setItems(R.array.select_image_actions, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
	                        if (which==0) {
	                        	goToCapture();
	                        } else if (which==1) {
	                        	goToGallery();
	                        }
                    }
                })
                .create();
        }
        return null;
    }
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
                                
        Utils.setActivity(this);
        
        try {
			DataFramework.getInstance().open(this, Utils.appPackage);
		} catch (Exception e) {
			e.printStackTrace();
		}
/*
		AdManager.setTestDevices( new String[] { "4F6BC4DC36BCF157E27DD052C8B299A1" } );
*/
		setContentView(R.layout.main);
		
		mContentLayout = (LinearLayout) this.findViewById(R.id.content);
		
		mWorkspaceView = new WorkspaceView(this, null);
		mWorkspaceView.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
		
		Button btAddPhoto = (Button) this.findViewById(R.id.bt_new_photo);
		
		btAddPhoto.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				showDialogImages();			
			}
			
		});
		
		Button btMix = (Button) this.findViewById(R.id.bt_mix);
		
		btMix.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				goToPrepareMix();						
			}
			
		});
		
		llBlack = (LinearLayout) this.findViewById(R.id.layout_black);
		
		fillImages();
		
    }
    
    public void fillImages() {
    	
    	mWorkspaceView.removeAllViews();
    	mArrayAdapter.clear();
    	
    	List<Entity> groups = DataFramework.getInstance().getEntityList("groups", "", DataFramework.KEY_ID+" asc");
    	
    	for (int i=0; i<groups.size()-1; i++) {
    		List<Entity> entities = DataFramework.getInstance().getEntityList("images", "group_id="+groups.get(i).getId(), "");
    		if (entities.size()<=0) {
    			groups.get(i).delete();
    		}
    	}
    	    	
    	// poner ltimo en blanco
    	
    	if (groups.size()>0) {
    		List<Entity> entities = DataFramework.getInstance().getEntityList("images", "group_id="+groups.get(groups.size()-1).getId(), "");
    		if (entities.size()>0) {
    			Entity ent = new Entity("groups");
    			ent.setValue("name", "Group " + entities.size());
    			ent.save();
    		}
    	}
    	
    	groups = DataFramework.getInstance().getEntityList("groups", "", DataFramework.KEY_ID+" asc");
    	
    	String[] names = new String[groups.size()];
    	
    	int count = 0;
    	
    	for (Entity group : groups) {
	    	ArrayList<Img> images = new ArrayList<Img>(); 
	    	
	    	names[count] = group.getString("name");
	    	count++;
	    		    	
	    	List<Entity> entities = DataFramework.getInstance().getEntityList("images", "group_id="+group.getId(), "");
	    	
	    	if (entities.size()>0) {
		    	GridView mGridPhotos = new GridView(this);
		    	mGridPhotos.setSelector(android.R.color.transparent);
		    	
		    	mGridPhotos.setNumColumns(GridView.AUTO_FIT);
		    	mGridPhotos.setHorizontalSpacing(20);
		    	mGridPhotos.setVerticalSpacing(20);
		    	mGridPhotos.setColumnWidth(72);
		    	mGridPhotos.setGravity(Gravity.CENTER);
		    	//mGridPhotos.setStretchMode(GridView.STRETCH_SPACING);
				

				mGridPhotos.setOnItemClickListener(new OnItemClickListener() {
		
					@Override
					public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
						showActionsPhoto(position);
					}
					
				});
		    	for (Entity ent : entities) {
		    		Img img = new Img();
		    		img.id = ent.getId();
		    		img.basename = ent.getString("basename");
		    		img.name = ent.getString("name");
		    		img.filename = ent.getString("file");
		    		
		    		//Log.d(Utils.TAG, "File: " + ent.getString("file") + " en grupo " + group.getId());
		    		
		    		img.image = Utils.getBitmapFromFile(ent.getString("file"), Utils.HEIGHT_IMAGE, true, 5);
		    		
		    		images.add(img);
		    		
		    	}
		    	
		    	PhotosViewAdapter mPhotosAdapter = new PhotosViewAdapter(this, images);
		    	
		    	mGridPhotos.setAdapter(mPhotosAdapter);
		    	
		    	mWorkspaceView.addView(mGridPhotos);
		    	
		    	mArrayAdapter.add(mPhotosAdapter);
		    	
	    	} else {
	    		
	    		TextView mTextEmpty = new TextView(this);
	    		mTextEmpty.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
	    		mTextEmpty.setGravity(Gravity.CENTER);
	    		mTextEmpty.setClickable(true);
	    		mTextEmpty.setText(R.string.no_photos_group);
	    		mWorkspaceView.addView(mTextEmpty);
	    		
	    	}
    	
    	}
    	    	
    	// configurar
		mWorkspaceView.configTabs((LinearLayout)findViewById(R.id.tabs), R.drawable.tab, R.drawable.tab_sel, Color.BLACK, Color.BLACK, 
				names);
		
		mContentLayout.removeAllViews();
		
		mContentLayout.addView(mWorkspaceView);
    	
    	
    }
    
    public long getCurrentGroup() {
    	List<Entity> groups = DataFramework.getInstance().getEntityList("groups", "", DataFramework.KEY_ID+" asc");
    	return groups.get(mWorkspaceView.getCurrentScreen()).getId();
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        menu.add(0, PREFERENCES_ID, 0,  R.string.preferences)
			.setIcon(android.R.drawable.ic_menu_preferences);
        return true;
    }
    
    public void showDialogImages() {
    	showDialog(DIALOG_IMAGE);
    }
    
    public void goToCapture() {
    	File f = new File(Utils.auxPhoto);
		if( f.exists() ) f.delete();
    	Intent intendCapture = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
    	intendCapture.putExtra(MediaStore.EXTRA_OUTPUT, Uri.fromFile(f));
    	intendCapture.putExtra("return-data", true);
    	startActivityForResult(intendCapture, ACTIVITY_CAMERA);
    }
    
    public void goToGallery() {
    	Intent i = new Intent(Intent.ACTION_PICK) ;
    	i.setDataAndType(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, 
    					 MediaStore.Images.Media.CONTENT_TYPE);
    	//startActivityForResult(i, ACTIVITY_SELECTIMAGE);
    	startActivityForResult(Intent.createChooser(i, getString(R.string.gallery)), ACTIVITY_SELECTIMAGE);
    }
    
    public void goToPrepareMix() {
    	Intent iprepare = new Intent(this, PrepareMix.class);
    	iprepare.putExtra("group", getCurrentGroup());
        startActivity(iprepare);
    }
    
    @Override
    public boolean onMenuItemSelected(int featureId, MenuItem item) {
        switch(item.getItemId()) {
        case PREFERENCES_ID:
        	Intent pref = new Intent(this, Preferences.class);
            startActivity(pref);
            return true;
        }
       
        return super.onMenuItemSelected(featureId, item);
    }

    
    private void deletePhoto() {
    	
    	Img img = mArrayAdapter.get(mWorkspaceView.getCurrentScreen()).getItem(mPosDeletePhoto);
    	
    	File f = new File(img.filename);
		if (f.exists()) f.delete();
		
    	Entity ent = new Entity("images", img.id);
    	ent.delete();
    	
    	fillImages();

    }
    
    public void addImage(String file) {
    	String dirGroup = Utils.appDirectory + getCurrentGroup() + "/";
    	Utils.createDirectory(dirGroup);
    	
    	String basename = SystemClock.elapsedRealtime()+"";
    	String fileDestiny = dirGroup + basename + ".png";
    	
		try {
			Utils.copy(file, fileDestiny);
		} catch (Exception e) {
			Utils.showMessage(this, "Error al copiar la imagen");
		}
		
		Entity ent = new Entity("images");
		ent.setValue("name", Utils.getName(file));
		ent.setValue("basename", basename);
		ent.setValue("file", fileDestiny);
		ent.setValue("group_id", getCurrentGroup());
		ent.save();
				
		fillImages();
    }
    
    @Override
    protected void onActivityResult(int requestCode, int resultCode, 
                                    Intent intent) {
        super.onActivityResult(requestCode, resultCode, intent);
        
		switch (requestCode){
    	case ACTIVITY_CAMERA:
    		if( resultCode != 0 ) {
    			Intent embed = new Intent(this, AdjustImage.class);
    			embed.putExtra("file", Utils.auxPhoto);
    			embed.putExtra("group", getCurrentGroup());
                startActivityForResult(embed, ACTIVITY_EMBED);	
    		}
    		break ;
    	case ACTIVITY_EMBED:
    		if( resultCode != 0 ) {
    			addImage(Utils.auxPhoto);
    		}
    		break ;
    	case ACTIVITY_SELECTIMAGE:
    		if( resultCode != 0 ) {
	    		Cursor c = managedQuery(intent.getData(),null,null,null,null);
	    		if (c!=null) {
		    		if( c.moveToFirst() ) {
		    			String media_path = c.getString(1);
		    			Intent embed = new Intent(this, AdjustImage.class);
		    			embed.putExtra("file", media_path);
		    			embed.putExtra("group", getCurrentGroup());
		                startActivityForResult(embed, ACTIVITY_EMBED);		
		    		}
	    		} else {
	    			Utils.showMessage(this, getString(R.string.generic_problem));
	    		}
    		}
    		break;
        }
    }
    
    public Bitmap getResizedBitmap(Bitmap bm, int newHeight, int newWidth) {

    	int width = bm.getWidth();

    	int height = bm.getHeight();

    	float scaleWidth = ((float) newWidth) / width;

    	float scaleHeight = ((float) newHeight) / height;

    	Matrix matrix = new Matrix();

    	matrix.postScale(scaleWidth, scaleHeight);

    	Bitmap resizedBitmap = Bitmap.createBitmap(bm, 0, 0, width, height, matrix, false);

    	return resizedBitmap;

    }
    
    private void moveImage(long id) {
    	String dirGroup = Utils.appDirectory + id + "/";
    	
    	File dir = new File(dirGroup);
    	if (!dir.exists()) dir.mkdir();
    	
    	Entity ent = new Entity("images", mImgSelected.id);
    	
    	String fileOrig = ent.getString("file");
    	
    	File f = new File(fileOrig);
    	
    	if (f.exists()) {
	    	String fileDestiny = dirGroup + ent.getString("basename") + ".png";
	    	
	    	try {
				Utils.copy(fileOrig, fileDestiny);
				
				
				f.delete();
				
		    	ent.setValue("file", fileDestiny);
		    	
		    	ent.setValue("group_id", id);
		    	ent.save();
		    	
			} catch (Exception e) {
				Utils.showMessage(FaceMix.this, "Error al copiar la imagen");
			}
			
    	} else {
    		Utils.showMessage(FaceMix.this, "Archivo no existe: " + fileOrig);
    	}
    }
    
    public void showActionsPhoto(int position) {
    	isActionsPhoto = true;
    	mPosDeletePhoto = position;
    	
    	llBlack.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				hideActionsPhoto();
			}
    		
    	});
    	
    	mImgSelected = mArrayAdapter.get(mWorkspaceView.getCurrentScreen()).getItem(mPosDeletePhoto);
    	
    	ImageView photo = (ImageView) this.findViewById(R.id.action_photo);
    	photo.setImageBitmap(mImgSelected.image);
    	    	
    	Button left = (Button) this.findViewById(R.id.action_left);
    	
    	if (mWorkspaceView.isFirstScreen()) {
    		left.setVisibility(View.INVISIBLE);
    	} else {
    		left.setVisibility(View.VISIBLE);
    	}
    	
    	left.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				List<Entity> groups = DataFramework.getInstance().getEntityList("groups", "", DataFramework.KEY_ID+" asc");
		    	long id = groups.get(mWorkspaceView.getCurrentScreen()-1).getId();
		    	moveImage(id);		
		    	fillImages();
		    	hideActionsPhoto();
		    	mWorkspaceView.scrollLeft();
			}
    		
    	});
    	
    	Button right = (Button) this.findViewById(R.id.action_right);
    	
    	if (mWorkspaceView.isLastScreen()) {
    		right.setVisibility(View.INVISIBLE);
    	} else {
    		right.setVisibility(View.VISIBLE);
    	}
    	
    	right.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				List<Entity> groups = DataFramework.getInstance().getEntityList("groups", "", DataFramework.KEY_ID+" asc");
		    	long id = groups.get(mWorkspaceView.getCurrentScreen()+1).getId();
		    	
		    	moveImage(id);
		    	
		    	fillImages();
		    	hideActionsPhoto();
		    	mWorkspaceView.scrollRight();
			}
    		
    	});
    	
    	Button delete = (Button) this.findViewById(R.id.action_delete);
    	
    	delete.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				hideActionsPhoto();
				showDialog(DIALOG_DELETE);
			}
    		
    	});
    	
    	llBlack.setVisibility(View.VISIBLE);
		LayoutAnimationController lac = AnimationUtils.loadLayoutAnimation(this, R.anim.inlayout_image);
		llBlack.setLayoutAnimation(lac);
		llBlack.setLayoutAnimationListener(null);
		llBlack.startLayoutAnimation();
    	
    }
    
    public void hideActionsPhoto() {
    	llBlack.setVisibility(View.INVISIBLE);
    	llBlack.setVisibility(View.VISIBLE);
    	LayoutAnimationController lac = AnimationUtils.loadLayoutAnimation(this, R.anim.outlayout_image);
    	llBlack.setLayoutAnimation(lac);
    	llBlack.setLayoutAnimationListener(new AnimationListener() {
            @Override
            public void onAnimationEnd(Animation lac) {
            	isActionsPhoto = false;
            	LinearLayout ll = (LinearLayout) findViewById(R.id.layout_black);
            	ll.setVisibility(View.GONE);
            }
    
            @Override
            public void onAnimationRepeat(Animation animation) { }
    
            @Override
            public void onAnimationStart(Animation animation) { }
    
        });
    	llBlack.startLayoutAnimation();
    	//llBlack.setVisibility(View.GONE);
    }
    
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
        	if (isActionsPhoto) {
        		hideActionsPhoto();
        		return false;
        	}
        }
        return super.onKeyDown(keyCode, event);
    }
    
	@Override
	protected void onDestroy() {
		super.onDestroy();
		DataFramework.getInstance().close();
	}
    
}